//sword.cs
datablock AudioProfile(lifescytheDrawSound)
{
   filename    = "./lifescytheDraw.wav";
   description = AudioClosest3d;
   preload = true;
};
datablock AudioProfile(lifescytheHitSound)
{
   filename    = "./lifescytheHit.wav";
   description = AudioClosest3d;
   preload = true;
};


//effects
datablock ParticleData(lifescytheTrailParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 1.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   spinRandomMin = -90;
   spinRandomMax = 90;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 300;
   textureName          = "base/data/particles/dot";
   colors[0]     = "0.9 0.7 0.0 0.5";
   colors[1]     = "0.9 0.3 0.0 0.0";
   sizes[0]      = 1;
   sizes[1]      = 0.25;
};

datablock ParticleEmitterData(lifescytheTrailEmitter)
{
   ejectionPeriodMS = 5;
   periodVarianceMS = 0;
   ejectionVelocity = 3;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "lifescytheTrailParticle";

   uiName = "lifescythe Trail";
};





datablock ParticleData(lifescytheExplosionParticle)
{
   dragCoefficient      = 2;
   gravityCoefficient   = 1.0;
   inheritedVelFactor   = 0.2;
   constantAcceleration = 0.0;
   spinRandomMin = -90;
   spinRandomMax = 90;
   lifetimeMS           = 500;
   lifetimeVarianceMS   = 300;
   textureName          = "base/data/particles/dot";
   colors[0]     = "1.0 1.0 1.0 1.0";
   colors[1]     = "1.0 1.0 1.0 0.0";
   sizes[0]      = 2;
   sizes[1]      = 1;
};

datablock ParticleEmitterData(lifescytheExplosionEmitter)
{
   ejectionPeriodMS = 7;
   periodVarianceMS = 0;
   ejectionVelocity = 8;
   velocityVariance = 1.0;
   ejectionOffset   = 0.0;
   thetaMin         = 0;
   thetaMax         = 60;
   phiReferenceVel  = 0;
   phiVariance      = 360;
   overrideAdvance = false;
   particles = "lifescytheExplosionParticle";

   uiName = "lifescythe Hit";
};

datablock ExplosionData(lifescytheExplosion)
{
   //explosionShape = "";
   lifeTimeMS = 500;

   soundProfile = lifescytheHitSound;

   particleEmitter = lifescytheExplosionEmitter;
   particleDensity = 10;
   particleRadius = 0.2;

   faceViewer     = true;
   explosionScale = "1 1 1";

   shakeCamera = true;
   camShakeFreq = "20.0 22.0 20.0";
   camShakeAmp = "1.0 1.0 1.0";
   camShakeDuration = 0.5;
   camShakeRadius = 10.0;

   // Dynamic light
   lightStartRadius = 3;
   lightEndRadius = 0;
   lightStartColor = "00.0 0.2 0.6";
   lightEndColor = "0 0 0";
};


//projectile
AddDamageType("lifescythe",   '<bitmap:add-ons/Weapon_LifeScythe/CI_lifescythe> %1',    '%2 <bitmap:add-ons/Weapon_LifeScythe/CI_lifescythe> %1',0.75,1);
datablock ProjectileData(lifescytheAttackProjectile)
{
   directDamage        = 35;
   directDamageType  = $DamageType::lifescythe;
   radiusDamageType  = $DamageType::lifescythe;
   explosion           = lifescytheExplosion;
   particleEmitter     = lifescytheTrailEmitter;

   muzzleVelocity      = 100;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 1000;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "lifescythe Attack Beam";
};

datablock ProjectileData(lifescytheLifeProjectile)
{
   directDamage        = 35;
   directDamageType  = $DamageType::lifescythe;
   radiusDamageType  = $DamageType::lifescythe;
   explosion           = lifescytheExplosion;
   particleEmitter     = lifescytheTrailEmitter;

   muzzleVelocity      = 100;
   velInheritFactor    = 1;

   armingDelay         = 0;
   lifetime            = 1000;
   fadeDelay           = 70;
   bounceElasticity    = 0;
   bounceFriction      = 0;
   isBallistic         = false;
   gravityMod = 0.0;

   hasLight    = false;
   lightRadius = 3.0;
   lightColor  = "0 0 0.5";

   uiName = "lifescythe Life Beam";
};


//////////
// item //
//////////
datablock ItemData(lifescytheItem)
{
	category = "Weapon";  // Mission editor category
	className = "Weapon"; // For inventory system

	 // Basic Item Properties
	shapeFile = "./lifescythe.dts";
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	//gui stuff
	uiName = "Scythe of Life";
	iconName = "./icon_lifescythe";
	doColorShift = true;
	//colorShiftColor = "0.471 0.471 0.471 1.000";
	colorShiftColor = "1.0 1.0 1.0 1.0";

	 // Dynamic properties defined by the scripts
	image = lifescytheImage;
	canDrop = true;
};

////////////////
//weapon image//
////////////////
datablock ShapeBaseImageData(lifescytheImage)
{
   // Basic Item properties
   shapeFile = "./lifescythe.dts";
   emap = true;

   // Specify mount point & offset for 3rd person, and eye offset
   // for first person rendering.
   mountPoint = 0;
   offset = "0 0 0";

   // When firing from a point offset from the eye, muzzle correction
   // will adjust the muzzle vector to point to the eye LOS point.
   // Since this weapon doesn't actually fire from the muzzle point,
   // we need to turn this off.  
   correctMuzzleVector = false;

   eyeOffset = "0.7 1.2 -0.25";

   // Add the WeaponImage namespace as a parent, WeaponImage namespace
   // provides some hooks into the inventory system.
   className = "WeaponImage";

   // Projectile && Ammo.
   item = lifescytheItem;
   ammo = " ";
   projectile = lifescytheAttackProjectile;
   projectileType = Projectile;

   //melee particles shoot from eye node for consistancy
   melee = false; //not anymore sucka
   doRetraction = false;
   //raise your arm up or not
   armReady = true;

   //casing = " ";
   doColorShift = true;
   //colorShiftColor = "0.471 0.471 0.471 1.000";
   colorShiftColor = "1.0 1.0 1.0 1.0";

   // Images have a state system which controls how the animations
   // are run, which sounds are played, script callbacks, etc. This
   // state system is downloaded to the client so that clients can
   // predict state changes and animate accordingly.  The following
   // system supports basic ready->fire->reload transitions as
   // well as a no-ammo->dryfire idle state.

   // Initial start up state
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.2;
	stateTransitionOnTimeout[0]      = "Ready";
	stateSound[0]                    = lifescytheDrawSound;

	stateName[1]                     = "Ready";
	stateTransitionOnTriggerDown[1]  = "PreFire";
	stateAllowImageChange[1]         = true;

	stateName[2]			= "PreFire";
	stateScript[2]                  = "onPreFire";
	stateAllowImageChange[2]        = false;
	stateTimeoutValue[2]            = 0.1;
	stateTransitionOnTimeout[2]     = "Fire";

	stateName[3]                    = "Fire";
	stateTransitionOnTimeout[3]     = "PostFire";
	stateTimeoutValue[3]            = 0.2;
	stateFire[3]                    = true;
	stateAllowImageChange[3]        = false;
	stateSequence[3]                = "Fire";
	stateScript[3]                  = "onFire";
	stateWaitForTimeout[3]		= true;

	stateName[4]                    = "PostFire";
	stateTransitionOnTimeout[4]     = "StopFire";
	stateTimeoutValue[4]            = 0.01;
	stateAllowImageChange[4]        = false;
	stateSequence[4]                = "PostFire";
	stateScript[4]                  = "onPostFire";
	stateWaitForTimeout[4]		= true;

	stateName[5]                    = "StopFire";
	stateTransitionOnTimeout[5]     = "Ready";
	stateTimeoutValue[5]            = 0.3;
	stateAllowImageChange[5]        = false;
	stateWaitForTimeout[5]		= true;
	stateSequence[5]                = "StopFire";
	stateScript[5]                  = "onStopFire";


};

function lifescytheImage::onPreFire(%this, %obj, %slot)
{
	//%obj.playthread(2, armattack);
	%obj.playthread(2, spearthrow);
	%obj.playthread(3, rotCCW);
	%obj.playthread(4, shiftUp);
}

//spawns multiple attack bullets and one life bullet.
function lifescytheImage::onFire(%this, %obj, %slot)
{
  %fvec = %obj.getForwardVector();
  %fX = getWord(%fvec,0);
  %fY = getWord(%fvec,1);
  
  %evec = %obj.getEyeVector();
  %eX = getWord(%evec,0);
  %eY = getWord(%evec,1);
  %eZ = getWord(%evec,2);
  
  %eXY = mSqrt(%eX*%eX+%eY*%eY);
  
  %aimVec = %fX*%eXY SPC %fY*%eXY SPC %eZ;

	%projectile = lifescytheAttackProjectile;
	%spread = 0.03;
	%shellcount = 7;

	for(%shell=0; %shell<%shellcount; %shell++)
	{
		%vector = %obj.getMuzzleVector(%slot);
		%objectVelocity = %obj.getVelocity();
		%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
		%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
		%velocity = VectorAdd(%vector1,%vector2);
		%x = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%y = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%z = (getRandom() - 0.5) * 10 * 3.1415926 * %spread;
		%mat = MatrixCreateFromEuler(%x @ " " @ %y @ " " @ %z);
		%velocity = MatrixMulVector(%mat, %velocity);

		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
	}
	//return %p;





	%projectile = "lifescytheLifeProjectile";
	
	%vector = %obj.getMuzzleVector(%slot);
	%objectVelocity = %obj.getVelocity();
	%vector1 = VectorScale(%vector, %projectile.muzzleVelocity);
	%vector2 = VectorScale(%objectVelocity, %projectile.velInheritFactor);
	%velocity = VectorAdd(%vector1,%vector2);

	
		%p = new (%this.projectileType)()
		{
			dataBlock = %projectile;
			initialVelocity = %velocity;
			initialPosition = %obj.getMuzzlePoint(%slot);
			sourceObject = %obj;
			sourceSlot = %slot;
			client = %obj.client;
		};
		MissionCleanup.add(%p);
		return %p;
}

function lifescytheImage::onPostFire(%this, %obj, %slot)
{
	//%obj.playthread(2, armattack);
	%obj.playthread(2, spearthrow);
	%obj.playthread(3, rotCCW);
	%obj.playthread(4, shiftUp);
	
}

function lifescytheImage::onStopFire(%this, %obj, %slot)
{	
	%obj.playthread(2, root);
	//%obj.playthread(3, root);
	//%obj.playthread(4, root);
}





//prefs

if(!isObject(summonGroup))
{
	new simGroup(summonGroup);
}


function serverCmdClearSummons(%client)
{
	if(%client.isAdmin || %client.isSuperAdmin)
	{
		messageAll("", "\c2" @ %client.name @ " \c3cleared all summons.");
		for(%i = 0; %i < summonGroup.getCount(); %i++)
		{
			summonGroup.getObject(%i).schedule(10, "kill");
		}
	}
}


$prefsummonlimit = 15;

//now we are getting into more complicated matters. spawning a bot from this thing.
function lifescytheLifeProjectile::onCollision(%this,%obj,%col,%fade,%pos,%normal)
{

	//yeah the only thing I can use is AIPlayer. DAMN.
	//i'll have to take a look at Gamemode_Blockheads_Ruin_Xmas so I can just. use the AI there. and win.
	//bot loop thing
	//%obj.hSummonTimer++;
	//if(%obj.hSummonTimer >= 10)
	//{
	//	%obj.kill();
	//} //kills bot after time

	if(summonGroup.getCount() < $prefsummonlimit)
		SummonEnemy(%obj, %obj.client.player, 1, 1);

	

}


function SummonEnemy(%obj, %client, %num, %summoncount)
{

	
		%pos = vectorAdd(vectorScale(%obj.getForwardVector(), 3) @ " 0 0 0 0", %obj.getTransform());

		%summon = new AIPlayer()
		{
			datablock = "SummonA";
			position = %pos;
		};
   		missionCleanup.add(%summon);
		%summon.client = %summon;
		%summon.player = %summon;
		%summon.minigame = %obj.client.minigame;
	
      		//%skin=HSVtoRGB(0.626, getrandom(),0.453) SPC 1;
		%skin = "0.626 0.71 0.453 1";

	
   		%summon.setnodecolor("headSkin", %skin);
   		%summon.setnodecolor("Chest", "0.75 0.75 0.75 1");
   		%summon.setnodecolor("lArm", "0.593 0 0 1");
   		%summon.setnodecolor("rArm", "0.593 0 0 1");
   		%summon.setnodecolor("lHand", %skin);
   		%summon.setnodecolor("rHand", %skin);
   		%summon.setnodecolor("lShoe", "0 0.141 0.333 1");
   		%summon.setnodecolor("rShoe", "0 0.141 0.333 1");
   		%summon.setnodecolor("pants", "0 0.141 0.333 1");
	
		%summon.playthread(1,"ArmReadyBoth");

		%summon.SummonTimer = 0;

		summonGroup.add(%summon);
		%summon.mountimage(swordImage,0); //they get swords yo
		playersearchloop(%summon);
  		return(%summon);
}




//ai i ripped from gamemode_zombie. sorry rotondo. but. yeah.





//%client.tdmTeam -1 no team 0 - 5
function AiPlayer::zFollow(%player,%id)
{
	%player.isfollowing = 1;
	%player.setmovey(1);
	%player.setmoveobject(%id);
	%player.isAniStop = 0;
	%player.playthread(3,root);
	%player.doublefollow = 1;
	%player.isfollowingid = %id;
	if(%player.getdatablock().aimatplayer == 1)
	{
		%player.setaimobject(%id);
	}
	if(%player.armsup == 0)
	{
		%player.playthread(1,%player.getdatablock().FollowAnim);
		%player.armsup = 1;
	}
	if(getword(%player.getposition(),2)+1 < getword(%id.getposition(),2))
	{
		%player.setimagetrigger(2,1);
		%player.schedule(2000,setimagetrigger,2,0);
	}
	if(getword(%player.getposition(),2) > getword(%id.getposition(),2)+0.5 || %id.iscrouched())
	{
			%player.setimagetrigger(3,1);
			%player.schedule(2000,setimagetrigger,3,0);
	}
		
}
//stops console spam ok ok
function AiPlayer::IncScore(%obj)
{
	//wait what?
}
function AiPlayer::ValidateAvatarPrefs(%obj)
{
	//wait what?
}

function playersearchloop(%player)
{
	//echo("Tick Tock"); //ha ha get it because its TICKS
	if(!isobject(%player))
	{
		return;
	}
	if(IsInMinigame(%player) == 0 || IsInMinigame(%player) == -1)
	{	
		return;

	}

	if(!isObject(%player.doublefollow))
		%player.doublefollow = 0;
	//PlayerSearch(%player);
	if(!isObject(%player.lifespan))
		%player.lifespan = 0;

	
	%player.firstjumps = schedule(500,0,ZombieJumpSearch,%player);
	%player.secondjumps = schedule(2000,0,ZombieJumpSearch,%player);


	if(%player.doublefollow != 1)
	{
		%foundp = PlayerSearch(%player);
		//%foundp = testblah(%player);
		if(%foundp == 1)
		{
			%player.schedule(200,Attack);
		}
		if(%foundp == 0)
		{
			%player.isfollowing = 0; //just... wander around i guess.
			%player.stopthread(1);
			%player.armsup = 0;
			%player.setmoveobject("");
			%dest = Randomwalk(%player);
			%player.setmoveDestination(%dest);

		}
	}
	if(%player.doublefollow == 1)
	{
		%player.doublefollow = 0;
	}
	//echo(%player.gettransform() SPC %player.getvelocity());
	
	//if(%player.lifespan >= 5) //15 second limit

	
	//%player.lifespan++;


	%player.searchsched = schedule(3000,0,playersearchloop,%player);

}
 function PlayerSearch(%player)
{
	if(%player)
	{
		%searchMasks = $TypeMasks::PlayerObjectType;

		//chance zombies will attack
		%chance = 80; //can be set to anything i guess80;
		//Radius
		%radius = 64;

		%pos = %player.getPosition();
		InitContainerRadiusSearch(%pos, %radius, %searchMasks);
	  
		while ((%targetid = containerSearchNext()) != 0 )
		{
			%id = %targetid.getId();
			//if(%id.getClassName() $= "Player" && IsInMinigame(%player) && IsInSameMinigame(%id,%player))
			if(IsInMinigame(%player) && IsInSameMinigame(%id,%player) && %id != %player)
			{
				%exc = 0;
				if(%id.getClassName() $= "AIPlayer")
					%exc = 1;

				if(getrandom(0,100) <= %chance && %exc != 1) //if chance is good and %exc is not 1
				{
					if(ZombieLOSCheck(%id,%player))
					{
						%player.zFollow(%id);
						return 1;
					}
				}
			}
		}  
	}
	%player.clearmovey();
	return 0;
}
function ZombieJumpSearch(%this)
{
	if(isobject(%this) && %this.getstate !$= "Dead") //if "this" isn't dead. "this" being the AIPlayer.
	{
		%eyeVec = %this.getforwardVector();

		//%startPos = vectoradd(vectoradd(%this.getposition(),"0 0 1"),"0" SPC getword(%eyeVec,1)*2 SPC "0");
		%startPos = vectoradd(%this.getEyePoint(),"0 0 -0.5");
		
		%endPos = VectorAdd(%startPos,vectorscale(%eyeVec,8));

		%mask = $TypeMasks::FxBrickObjectType | $typemasks::PlayerObjectType | $TypeMasks::InteriorObjectType;
		%target = ContainerRayCast(%startPos, %endPos, %mask,%this);
		//food(%startpos,%eyevec);

		if (%target)
		{
			//echo(%target);
			jumpbrick(getword(%target,0),%this);
			if(%target.getclassname() $= "FxDtsBrick" && %target.numevents >= 1) //how courteous.
			{
				%target.onactivate(%this,%this);
			}
		}
	}
}
function jumpbrick(%col,%obj)
{
	
	if(%col.getClassName() $= "FxDtsBrick")
	{
		%obj.setimagetrigger(2,1);
		%obj.schedule(500,setimagetrigger,2,0);
	}
	else
	{
		if(%col.getclassname() !$= "Player")
		{
			%obj.setimagetrigger(2,1);
			%obj.schedule(500,setimagetrigger,2,0);
		
		}
	}
}

function Randomwalk(%player)
{
	if(%player.getdatablock().aimatplayer == 1)
	{
		%player.setaimobject("");
	}
	%pos = %player.getposition();
	%ranpos = vectoradd(%pos,getrandom(-20,20) SPC getrandom(-20,20) SPC getword(%pos,2));
	if(getrandom(0,4) == 0)
	{
		%ranpos = %pos;
	}
	return %ranpos;
}

function IsInSameMinigame(%player,%bot)
{
	if(isobject(%player) && isobject(%bot))
	{
		if(%player.getclassname() $= "Player" && %bot.getclassname() $= "Player")
		{
			return 1;
		}
		if(%player.getclassname() $= "Player" && %bot.getclassname() $= "AiPlayer")
		{
			return 1;
		}
		if(%player.getclassname() $= "AiPlayer" && %bot.getclassname() $= "Player")
		{
			return 1;
		}
		if(%player.getclassname() $= "AiPlayer" && %bot.getclassname() $= "AiPlayer")
		{
			return 1;
		}
	}
	//return 0;
	return 1; //i'm going to cheat a bit. it will return 1 always.
}

function ZombieLOSCheck(%this,%obj)
{
	if(isobject(%this))
	{
		%tPos = %this.getPosition();
	}
	if(isobject(%obj))
	{
		%oPos = %obj.getposition();
	}
	if(vectordist(%tpos,%opos) <= 3)
	{
		return 1;
	}
	%dis = VectorSub(%oPos, %tPos);
	%normVec = VectorNormalize(%dis);

	//%eyeVec = %this.getEyeVector();
	%eyevec = %normVec;
				
	%startPos = vectoradd(%tpos,"0 0 2");
	%endPos = VectorAdd(%startPos,vectorscale(%eyeVec,100));

	%mask = $TypeMasks::FxBrickObjectType | $typemasks::PlayerObjectType | $TypeMasks::InteriorObjectType;
	%target = ContainerRayCast(%startPos, %endPos, %mask,%this);

	if(%target == %obj)
	{
		return 1;
	}
	else
	{
		return 0;
	}
}
function AiPlayer::Attack(%this,%onshot)
{	
	if(isobject(%this) && %this.getstate() !$= "Dead")
	{
		%this.setimagetrigger(0,1);
		%this.setimagetrigger(0,0);
	}
}
function AiPlayer::onDamage(%this, %obj, %source, %pos, %damage, %type )
{

	%obj.zFollow(%source.getID());
	ZombieJumpSearch(%obj);
}
function IsInMinigame(%player)
{
	if(isobject(%player))
	{
		if(%player.getclassname() $= "Player")
		{
			if(%player.client.minigame != 0 && %player.client.minigame != -1)
			{
				return 1;

			}
		}
		if(%player.getclassname() $= "AiPlayer")
		{
			return 1;
		}
		//return 0;
		return 1; //same thing
	}
}
function AIPlayer::onDeath(%this, %obj, %source)
{
	
}









datablock PlayerData(SummonA : PlayerStandardArmor)
{
	uiName = "";
	minJetEnergy = 0;
	jetEnergyDrain = 0;
	canJet = 0;
	maxItems   = 5;
	maxWeapons = 5;
	maxTools = 5;
	runforce = 100 * 90;
	maxForwardSpeed = 8;
	maxBackwardSpeed = 4;
	maxSideSpeed = 8;
	attackpower = 10;
	rideable = false;
	canRide = false;
	aimatplayer = 0;
};
